/**
 * Copyright (C) 2010 Cloudfarming <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package nl.cloudfarming.client.area.plot;

import java.util.Date;
import java.util.List;
import javax.persistence.Query;
import nl.cloudfarming.client.area.AreaService;
import nl.cloudfarming.client.model.CommonModelService;
import nl.cloudfarming.client.model.Plot;
import org.openide.util.lookup.ServiceProvider;

/**
 *
 * @author Timon Veenstra
 */
@ServiceProvider(service = AreaService.class)
public class PlotAreaService extends CommonModelService implements AreaService {

    @Override
    protected String getModuleName() {
        return PlotPersistingModule.MODULE_NAME;
    }

        public List<Plot> findAllCurrentPlots() {
        startTransaction();
        Query query = getEntityManager().createNamedQuery("findAllValidPLots");
        query.setParameter("date", new Date());
        return query.getResultList();
    }
}
